commit 12190adda9d9522577554554ad07080ba3e9a474
Author: freddy77 <freddy77>
Date:   Sun Jan 27 17:36:17 2008 +0000

    implemented SQL_ATTR_CONNECTION_DEAD

diff --git a/ChangeLog b/ChangeLog
index fd76f3b..1f7e2b8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Sun Jan 27 18:35:55 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c: 
+	- implemented SQL_ATTR_CONNECTION_DEAD
+
 Thu Jan 24 22:14:31 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/dblib.c src/tds/vstrbuild.c:
 	- va_list cleanups
@@ -95,4 +99,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2477 2008/01/24 21:14:55 freddy77 Exp $
+$Id: ChangeLog,v 1.2478 2008/01/27 17:36:17 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 74f8057..937a8d7 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.468 2008/01/14 19:21:06 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.469 2008/01/27 17:36:17 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -2030,8 +2030,8 @@ odbc_errmsg_handler(const TDSCONTEXT * ctx, TDSSOCKET * tds, TDSMESSAGE * msg)
 		if (tds && (dbc = (TDS_DBC *) tds->parent) && dbc->current_statement) {
 			TDS_STMT *stmt = dbc->current_statement;
 			/* cancel sent, handling interrupt */
-			if (tds->in_cancel && stmt ->cancel_sent) {
-				stmt ->cancel_sent = 0;
+			if (tds->in_cancel && stmt->cancel_sent) {
+				stmt->cancel_sent = 0;
 				tdsdump_log(TDS_DBG_INFO1, "returning from timeout\n");
 				return TDS_INT_TIMEOUT;
 			}
@@ -4443,6 +4443,11 @@ _SQLGetConnectAttr(SQLHDBC hdbc, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTE
 		*((SQLUINTEGER *) Value) = dbc->attr.autocommit;
 		ODBC_RETURN_(dbc);
 		break;
+#if defined(SQL_ATTR_CONNECTION_DEAD) && defined(SQL_CD_TRUE)
+		*((SQLUINTEGER *) Value) = IS_TDSDEAD(dbc->tds_socket) ? SQL_CD_TRUE : SQL_CD_FALSE;
+		ODBC_RETURN_(dbc);
+		break;
+#endif
 	case SQL_ATTR_CONNECTION_TIMEOUT:
 		*((SQLUINTEGER *) Value) = dbc->attr.connection_timeout;
 		ODBC_RETURN_(dbc);

